#include"windows.h"
string ButtonLabel[4]={
  "Zrusit","OK","Ano","Ne"
};
int Error=0;

//============================ TLabel ========================================
//--------------------------- TLabel::draw  -----------------------------------------
void TLabel::draw () {
  uint i;
  uint Width=B.X-A.X;
  uint Height=B.Y-A.Y;
  string Str=Caption;
  textattr (attrib (DIALOG_BACK,LABEL_INK));
  for(i=0; i<Height; i++){
    print_xyl (A.X,A.Y+i,Width,Str);
    if (strlen (Str)>=Width)
      Str=&Str[Width];
    else
      Str=NULL;
  }
} /* TLabel::draw */

//=========================== TButton ========================================
//--------------------------- TButton::draw  -----------------------------------------
void TButton::draw () {
  int Left;
  if (!OldAttr){  // prvni vykresleni - zapamatuje si barvu pod svym stinem
    char Z;
    get_char_attr (B.X,B.Y,Z,OldAttr);
  }
  draw_rect (A,B,attrib (0,BUTTON_BACK));
  draw_rect_shadow (A,B, attrib (get_B(OldAttr),BUTTON_SHADOW));

  Left=(((B.X-A.X)-strlen(Caption))/2)+A.X;
  uint Length=min (B.X-A.X, strlen (Caption));
  print_xyla (Left,A.Y,Length,Caption,attrib (BUTTON_BACK,BUTTON_INK));
} /* TButton::draw */

//--------------------------- TButton::set_active  -----------------------------------------
void TButton::set_active () {
  draw_rect (A,B,attrib (0,BUTTON_ACT_BACK));
  uint Left=(((B.X-A.X)-strlen(Caption))/2)+A.X;
  uint Length=min (B.X-A.X, strlen (Caption));
  print_xyla (Left,A.Y,Length,Caption,attrib (BUTTON_ACT_BACK,BUTTON_ACT_INK));
} /* TButton::set_active */

//--------------------------- TButton::set_inactive  -----------------------------------------
void TButton::set_inactive () {
  draw_rect (A,B,attrib (0,BUTTON_BACK));
  uint Left=(((B.X-A.X)-strlen(Caption))/2)+A.X;
  uint Length=min (B.X-A.X, strlen (Caption));
  print_xyla (Left,A.Y,Length,Caption,attrib (BUTTON_BACK,BUTTON_INK));
} /* TButton::set_inactive */

//--------------------------- TButton::handle_event  -------------------------
void TButton::handle_event (int Key){
  if (is_enabled())
    if (Key==K_ENTER){
      int OldColor=get_B(OldAttr);
      draw_rect_shadow (A,B, attrib (OldColor,OldColor));
      delay (130);
      draw_rect_shadow (A,B, attrib (OldColor,BUTTON_SHADOW));
      //set_click (TRUE);
      if (OnClick!=NULL) OnClick();
      if (Owner!=NULL)
	Owner->set_result (Options);
    }
} /* TButton::handle_event */

//=========================== TInputLine =====================================
//--------------------------- TInputLine::TInputLine  ------------------------

TInputLine::TInputLine (TPoint _A, TPoint _B, int _Length,
			string _Caption,
			string _ValidChars,
			uint _Options,
			void (*_OnClick)(),
			boolean _Enabled)
			:TComponent (_A,_B,_Options,_Enabled,_OnClick){
  // alokace pameti na vstupni retezec
  Length=_Length;
  Caption=new_str (Length);

  if (_Caption!=NULL)
    strncpy(Caption, _Caption, Length);
  else
    Caption[0]='\0';

//  OnClick=_OnClick;
  ValidChars=_ValidChars;
  CurPos=0;
  FirstLetter=0;
} /* TInputLine::TInputLine */

//--------------------------- TInputLine::draw  -----------------------------------------
void TInputLine::draw () {
//  draw_rect (A,B,attrib (0,INPUTLINE_BACK));
  string Pom=&(Caption[FirstLetter]);
  print_xyla (A.X,A.Y,B.X-A.X,Pom,attrib (INPUTLINE_BACK,INPUTLINE_INK));
  gotoxy (A.X+CurPos+1,A.Y+1);
} /* TInputLine::draw */

//--------------------------- TInputLine::handle_event  -----------------------------------------
void TInputLine::handle_event (int Key) {
// Posice kursoru ve slove = FirstLetter+CurPos
  int LineWidth=B.X-A.X;
  int OldFirstLetter=FirstLetter;
  int StrLen=strlen(Caption);
  int OldStrLen=StrLen;

  switch (Key){

    case K_LEFT:
      if (CurPos>0)
	CurPos--;
      else  // posice kursoru je uuuplne vlevo v okynku
	if (FirstLetter) FirstLetter--;
      break;

    case K_RIGHT:
      if (CurPos<LineWidth-1){
	if (CurPos<StrLen) CurPos++;}
      else
	if (FirstLetter+LineWidth-1<StrLen) FirstLetter++;
      break;

    case K_HOME:
      CurPos=0;
      FirstLetter=0;
      break;

    case K_END:
      if (StrLen<LineWidth-1){
	CurPos=StrLen;
	FirstLetter=0;
      }
      else {
	CurPos=LineWidth-1;
	FirstLetter=StrLen-LineWidth+1;
      }
      break;

    case K_BKSP:
      if ((CurPos) || (FirstLetter)){
	Caption=del_char(FirstLetter+CurPos-1,Caption);
	if (CurPos) CurPos--;
	else FirstLetter--;
      }
      break;

    case K_DEL:
      if (CurPos+FirstLetter<StrLen){
	Caption=del_char (CurPos+FirstLetter,Caption);
      }
      break;

    case K_ENTER:
      if (OnClick!=NULL)
	OnClick();
      break;

    default:{
      if (Key<256 && StrLen<Length && strchr(ValidChars,Key)){
	Caption=insert_char(CurPos+FirstLetter,Key,Caption);
	if (CurPos<LineWidth-1) CurPos++;
	else FirstLetter++;
      }

    }
  } // end switch

  if (OldStrLen==strlen(Caption) && OldFirstLetter==FirstLetter)
    gotoxy (A.X+CurPos+1,A.Y+1);
  else
    draw();

} /* TInputLine::handle_event */

//=========================== TVScrollBar ========================================
//--------------------------- TVScrollBar::calc_value  -----------------------------------------
void TVScrollBar::calc_value () {
  if (Max>0)
    Value=(Pos*(B.Y-A.Y-2))/Max;
  else
    Value=0;

  if (Value<0) Value=0;
  if (Value>=(B.Y-A.Y-2)) Value=B.Y-A.Y-3;

} /* TVScrollBar::calc_value */

//--------------------------- TVScrollBar::draw  -----------------------------------------
void TVScrollBar::draw () {

  if (!OldAttr){  // prvni vykresleni - zapamatuje si atributy pod sebou
    char Z;
    get_char_attr (A.X,A.Y,Z,OldAttr);
  }
  int Attr=attrib (SCROLLBAR_BACK,SCROLLBAR_INK);

  // vlastni vykresleni
  for(int i=A.Y; i<B.Y; i++)
    put_char_attr (A.X,i,SCROLL_CHAR,Attr);
  // Top
  put_char_attr (A.X,A.Y,SCROLL_UP_CHAR,Attr);
  // Bottom
  put_char_attr (A.X,B.Y-1,SCROLL_DOWN_CHAR,Attr);
  // Soupatko
  put_char_attr (A.X,A.Y+Value+1,SCROLL_POINT_CHAR,Attr);
} /* TVScrollBar::draw */

//--------------------------- TVScrollBar::redraw  -----------------------------------------
void TVScrollBar::redraw (long _Max, long _Pos) {
  int Attr=attrib (SCROLLBAR_BACK,SCROLLBAR_INK);
  uint OldValue=Value;
  // Obnovi promenne
  Max=_Max;
  Pos=_Pos;
  calc_value();

  if (Value!=OldValue){
    // Smaze stare soupatko
    put_char_attr (A.X,A.Y+OldValue+1,SCROLL_CHAR,Attr);

    // Vykresli nove soupatko
    put_char_attr (A.X,A.Y+Value+1,SCROLL_POINT_CHAR,Attr);
  }
} /* TVScrollBar::redraw */


//=========================== THScrollBar ========================================
//--------------------------- THScrollBar::calc_value  -----------------------------------------
void THScrollBar::calc_value () {
  if (Max>0)
    Value=(Pos*(B.X-A.X))/Max;
  else
    Value=0;
  if (Value<0) Value=0;
  if (Value>=(B.X-A.X-2)) Value=B.X-A.X-2;

} /* THScrollBar::calc_value */

//--------------------------- THScrollBar::draw  -----------------------------------------
void THScrollBar::draw () {
  if (!OldAttr){  // prvni vykresleni - zapamatuje si atributy pod sebou
    char Z;
    get_char_attr (A.X,A.Y,Z,OldAttr);
  }
  int Attr=attrib (SCROLLBAR_BACK,SCROLLBAR_INK);

  // vlastni vykresleni
  for(int i=A.X; i<B.X; i++)
    put_char_attr (i,A.Y,SCROLL_CHAR,Attr);
  // Top
  put_char_attr (A.X,A.Y,SCROLL_LEFT_CHAR,Attr);
  // Bottom
  put_char_attr (B.X,A.Y,SCROLL_RIGHT_CHAR,Attr);
  // Soupatko
  put_char_attr (A.X+Value+1,A.Y,SCROLL_POINT_CHAR,Attr);
} /* THScrollBar::draw */

//--------------------------- THScrollBar::redraw  -----------------------------------------
void THScrollBar::redraw (long _Max, long _Pos) {
  int Attr=attrib (SCROLLBAR_BACK,SCROLLBAR_INK);
  uint OldValue=Value;
  // Obnovi promenne
  Max=_Max;
  Pos=_Pos;
  calc_value();

  if (Value!=OldValue){
    // Smaze stare soupatko
    put_char_attr (A.X+OldValue+1,A.Y,SCROLL_CHAR,Attr);

    // Vykresli nove soupatko
    put_char_attr (A.X+Value+1,A.Y,SCROLL_POINT_CHAR,Attr);
  }

} /* THScrollBar::redraw */

//=========================== TCluster =======================================---

//--------------------------- array_of_str  -----------------------------------------
string* array_of_str (int Count, ...) {
  va_list ParList;
  string Arg;
  string* Array;
  string Pom;
  int i;

  va_start (ParList, Count);
  if ((Array=(string*)malloc(Count*sizeof (string)))==NULL)
    game_over ("Malo pameti (alokace pole stringu)");


  for(i=0; i<Count; i++){
    Arg=va_arg (ParList, string);
    Pom=new_str (strlen (Arg)+4);
    strcpy (&Pom[4],Arg);
    Array[i]=Pom;
  }
  return (Array);

} /* array_of_str */


//--------------------------- TCluster::~TCluster  -----------------------------------------
TCluster::~TCluster () {
  for(uint i=0; i<Count; i++)
    free (ItemsArray[i]);
  free (ItemsArray);
} /* TCluster::~TCluster */

//--------------------------- TCluster::draw  -----------------------------------------
void TCluster::draw () {
  for(uint i=0; i<Count; i++)
    print_xyla (A.X,A.Y+i,B.X-A.X,ItemsArray[i],attrib (CLUSTER_BACK,CLUSTER_INK));
  active_item (Selected);

} /* TCluster::draw */

//--------------------------- TCluster::uncheck_item  -----------------------------------------
void TCluster::uncheck_item (uint Item) {
  string Str=ItemsArray[Item];
  Str[1]=' ';
} /* TCluster::uncheck_item */
//--------------------------- TCluster::prepare_items  -----------------------------------------
void TCluster::prepare_items () {
  string Str;
  for(uint i=0; i<Count; i++){
    Str=ItemsArray[i];
    Str[0]=LeftCh;
    Str[1]=' ';
    Str[2]=RightCh;
  }
} /* TCluster::prepare_items */

//--------------------------- TCluster::active_item  -----------------------------------------
void TCluster::active_item (uint Item) {
  print_xyla (A.X,A.Y+Item,B.X-A.X,ItemsArray[Item],attrib (CLUSTER_ACT_BACK,CLUSTER_ACT_INK));
  goto_xy (A.X+1,A.Y+Item);
} /* TCluster::active_item */

//--------------------------- TCluster::inactive_item  -----------------------------------------
void TCluster::inactive_item (uint Item) {
  print_xyla (A.X,A.Y+Item,B.X-A.X,ItemsArray[Item],attrib (CLUSTER_BACK,CLUSTER_INK));
} /* TCluster::inactive_item */

//--------------------------- TCluster::handle_event  -----------------------------------------
void TCluster::handle_event (int Key) {
  switch (Key) {
    case K_UP:
    case K_LEFT:
      inactive_item (Selected);
      if (Selected==0) Selected=Count-1;
      else Selected--;
      active_item (Selected);
    break;

    case K_DOWN:
    case K_RIGHT:
      inactive_item (Selected);
      if (Selected==Count-1) Selected=0;
      else Selected++;
      active_item (Selected);
    break;

    case K_SPACE:
      check_item (Selected);
    break;
  }
} /* TCluster::handle_event */

//--------------------------- TCluster::checked  -----------------------------------------
boolean TCluster::checked (uint Item) {
  string Str=ItemsArray[Item];
  return (Str[1]==CheckMark);
} /* TCluster::checked */
//=========================== TCheckBoxes =====================================-----
//--------------------------- TCheckBoxes::check_item  -----------------------------------------
void TCheckBoxes::check_item (uint Item) {
  string Str=ItemsArray[Item];
  if (!checked (Item))
    Str[1]=CheckMark;
  else
    Str[1]=' ';
  active_item (Item);
} /* TCheckBoxes::check_item */
//=========================== TRadioButtons ===================================-------
//--------------------------- TRadioButtons::check_item  -----------------------------------------
void TRadioButtons::check_item (uint Item) {
  string Str;
  // vse povypiname
  for(uint i=0; i<Count; i++)
    if (checked (i)){
      uncheck_item (i);
      inactive_item (i);
    }
  Str=ItemsArray[Item];
  Str[1]=CheckMark;
  active_item (Item);

} /* TRadioButtons::check_item */
//=========================== TDialog ========================================
//--------------------------- array_of_comp  -----------------------------------------
TComponent** array_of_comp (int Count, ...) {
  va_list ParList;
  TComponent* Arg;
  TComponent** Array;
  int i;

  va_start (ParList, Count);
  if ((Array=(TComponent**)malloc(Count*sizeof (TComponent*)))==NULL)
    game_over ("Malo pameti (alokace pole komponent)");


  for(i=0; i<Count; i++){
    Arg=va_arg (ParList, TComponent*);
    Array[i]=Arg;
  }
  return (Array);
} /* array_of_comp */

//--------------------------- TDialog::TDialog  -----------------------------------------
TDialog::TDialog (TPoint _A, TPoint _B,
		  int _Count, TComponent** _Array,
		  byte _FrType,string _FrLabel,
		  int _FrColor):TView (_A,_B){
  Count=_Count;
  ArrayOfComp=_Array;
  FrType=_FrType;
  if (_FrLabel==NULL)
    FrLabel[0]='\0';
  else
    strncpy (FrLabel, _FrLabel,B.X-A.X-2);
  FrColor=_FrColor;
  Selected=0;
  Result=-1;
  for(uint i=0; i<Count; i++)
    ArrayOfComp[i]->set_owner (this);
  long Size=(B.X-A.X)*(B.Y-A.Y)*2;
  if ((VideoBuffer=(byte *)malloc (Size*sizeof(byte)))==NULL)
    game_over ("Malo pameti!!! (VideoBuffer pro TDialog)");
} /* TDialog::TDialog */
//--------------------------------------------------------------------------
//--------------------------- TDialog::~TDialog  -----------------------------------------
TDialog::~TDialog () {
  free (ArrayOfComp);
} /* TDialog::~TDialog */

//--------------------------- TDialog::draw  -----------------------------------------
void TDialog::draw () {
  window (1,1,MAX_X, MAX_Y);
  draw_rect(A,B,attrib(DIALOG_BACK, DIALOG_BACK));
  draw_frame (A,B,FrType,FrLabel,DIALOG_BACK,FrColor);
  window (A.X+2,A.Y+2,B.X-1, B.Y-1);

  for(int i=0; i<Count; i++)
    ArrayOfComp[i]->draw();
  ArrayOfComp[Selected]->set_active();
} /* TDialog::draw */

//--------------------------- TDialog::open  -----------------------------------------
int TDialog::open () {
  TCursor Cur=save_cursor ();
  save();
  Selected=0;
  while (!(ArrayOfComp[Selected]->is_enabled()) &&
	 !(Selected==Count)){
    Selected++;
    if (Selected>=Count)
      Selected=0;
  }

  draw();
  Result=-1;
  int Key;

  while (Result==-1)
    handle_event(read_key());
  close();
  restore_cursor (Cur);
  return (Result);
} /* TDialog::open */
//--------------------------- TDialog::close  -----------------------------------------
void TDialog::close () {
  window (1,1,MAX_X, MAX_Y);
  restore ();
} /* TDialog::close */
//--------------------------- TDialog::handle_event  -----------------------------------------
void TDialog::handle_event (int Key) {
  int OldSelected=Selected;
  switch (Key){

    case K_TAB:
      do{
	Selected++;
	if (Selected>=Count)
	  Selected=0;
      } while (!(ArrayOfComp[Selected]->is_enabled()) &&
	      !(Selected==OldSelected));
    break;

    case K_SH_TAB:
      do{
	Selected--;
	if (Selected<0)
	  Selected=Count-1;
      } while (!(ArrayOfComp[Selected]->is_enabled()) &&
	       !(Selected==OldSelected));
    break;

    case K_ESC:
      for(int i=0; i<Count; i++){
	if (ArrayOfComp[i]->get_options()==BT_CANCEL){
	  ArrayOfComp[i]->handle_event (K_ENTER);
	  break;
	} // end of if
      } // end of for
    break;

    default:
      ArrayOfComp[Selected]->handle_event(Key);

  }; // end of switch
  if (Selected!=OldSelected){
    ArrayOfComp[OldSelected]->set_inactive();
    ArrayOfComp[Selected]->set_active();
  } // end of if

} /* TDialog::handle_event */
//--------------------------- TDialog::set_result  -----------------------------------------
void TDialog::set_result (int _Result) {
  Result=_Result;
} /* TDialog::set_result */

//--------------------------- message_dlg  -----------------------------------------
uint message_dlg (string Message, uint BCount, ...) {
  uint Pom;
  if (BCount>4)
    BCount=4;


  uint ButtonWidth=12;    //sirka buttonku
  uint DialogWidth=max (BCount*(ButtonWidth+2),48);//sirka dialog boxu
  uint LabelHeight=(strlen (Message))/(DialogWidth-4)+1;
  uint DialogHeight=(5+LabelHeight);
  uint DialogX=(MAX_X-DialogWidth)/2;
  uint DialogY=(MAX_Y-DialogHeight)/2;
  uint BX=((DialogWidth-(BCount*(ButtonWidth+2)))/2);
  uint BY=DialogHeight-4;
  uint Arg;

  TComponent **Array;
  if ((Array=(TComponent**)malloc((1+BCount)*sizeof (TComponent*)))==NULL)
    game_over ("Malo pameti pro alokaci pole komponent (message_dlg)");

  TLabel *Label=new TLabel
    (point (1,0), point (DialogWidth-3,LabelHeight),Message);

  Array[0]=(TComponent*)Label;

  va_list ParList;
  va_start (ParList, BCount);
  TButton *Button;


  for(int i=0; i<BCount; i++){
    Arg=va_arg (ParList, uint);
    if (Arg>3) Arg=3;

    Button=new TButton
      (point (BX+i*ButtonWidth+2,BY),point(BX+((i+1)*ButtonWidth),BY+1),
       ButtonLabel[Arg],Arg);
    Array[i+1]=(TComponent*)Button;
  }

  TDialog *Dialog=new TDialog
    (point (DialogX,DialogY), point (DialogX+DialogWidth,DialogY+DialogHeight),
     BCount+1,Array,1,NULL,DARKGRAY);

  Pom=Dialog->open();
  delete Label;
  for(i=0; i<BCount; i++)
    delete Array[i+1];

  delete Dialog;
  return (Pom);


} /* message_dlg */

TDialog *ChooseFileDlg, *FindDlg, *ReplaceDlg, *SyntaxDlg;
//--------------------------- init_choosefile_dlg  -----------------------------------------
void init_choosefile_dlg () {
  TLabel *L1=new TLabel (point (2,1), point (9,2), "Soubor:");
  char Buffer[MAXPATH];
  getcwd(Buffer, MAXPATH);

  TInputLine *IL1=new TInputLine (point (11,1), point (53,2),MAXPATH, Buffer);
  TButton *B_OK=new TButton (point(30,3), point (40,4), "OK", BT_OK);
  TButton *B_C=new TButton (point(42,3), point (52,4), "Zrusit", BT_CANCEL);

  ChooseFileDlg=new TDialog (point(10,6), point(68,13),4,
    array_of_comp (4,IL1,L1,B_OK,B_C), FR_DOUBLE, "Vyber souboru", WHITE);
} /* init_choosefile_dlg */

//--------------------------- init_find_dlg  -----------------------------------------
void init_find_dlg () {
  TLabel *L1=new TLabel (point (2,1), point (15,2), "Hledany text:");
  TInputLine *IL=new TInputLine (point (16,1), point (43,2),50);

  TLabel *L2=new TLabel (point (2,3), point (9,4), "Zpusob:");
  string *Options1=array_of_str (2,"Rozlisovat a/A","Pouze cela slova");
  TCheckBoxes *Ch1=new TCheckBoxes (point (2,4), point (23,5),2,Options1);

  TLabel *L3=new TLabel (point (25,3), point (32,4), "Rozsah:");
  string *Scope=array_of_str (2,"Cely dokument","Vybrany blok");
  TRadioButtons *R1=new TRadioButtons (point (25,4), point (43,5),2,Scope);

  TButton *B_OK=new TButton (point(20,7), point (30,8), "OK", BT_OK);
  TButton *B_C=new TButton (point(32,7), point (42,8), "Zrusit", BT_CANCEL);


  FindDlg=new TDialog (point(15,6), point(63,17),8,
    array_of_comp (8,IL,L1,L2,L3,Ch1,R1,B_OK,B_C), FR_DOUBLE, "Hledani retezce", WHITE);
} /* init_find_dlg */

//--------------------------- init_replace_dlg  -----------------------------------------
void init_replace_dlg () {
  TLabel *L1=new TLabel (point (2,1), point (15,2), "Hledany text:");
  TInputLine *IL1=new TInputLine (point (16,1), point (43,2),50);

  TLabel *L4=new TLabel (point (2,3), point (15,4), "   Novy text:");
  TInputLine *IL2=new TInputLine (point (16,3), point (43,4),50);


  TLabel *L2=new TLabel (point (2,5), point (9,6), "Zpusob:");
  string *Options1=array_of_str (2,"Rozlisovat a/A","Pouze cela slova");
  TCheckBoxes *Ch1=new TCheckBoxes (point (2,6), point (23,7),2,Options1);

  TLabel *L3=new TLabel (point (25,5), point (32,6), "Rozsah:");
  string *Scope=array_of_str (2,"Cely dokument","Vybrany blok");
  TRadioButtons *R1=new TRadioButtons (point (25,6), point (43,7),2,Scope);

  TButton *B_OK=new TButton (point(4,9), point (14,10), "OK", BT_OK);
  TButton *B_ALL=new TButton (point(16,9), point (30,10), "Zmenit vse", BT_USERDEF);
  TButton *B_C=new TButton (point(32,9), point (42,10), "Zrusit", BT_CANCEL);


  ReplaceDlg=new TDialog (point(15,6), point(63,19),11,
    array_of_comp (11,IL1,IL2,L1,L2,L3,L4,Ch1,R1,B_OK,B_ALL,B_C), FR_DOUBLE, "Nahrazeni retezce", WHITE);

} /* init_replace_dlg */

//--------------------------- init_syntax_dlg  -----------------------------------------
void init_syntax_dlg () {
  string *Options=array_of_str (5,"Standartni","C,C++","HTML",
  "Prolog","Jiny");
  TRadioButtons *R=new TRadioButtons (point (2,1), point (17,5),5,Options);

  TLabel *L=new TLabel (point (2,7), point (14,8), "Jiny soubor:");
  TInputLine *IL=new TInputLine (point (2,8), point (34,9),MAXPATH);


  TButton *B_OK=new TButton (point(21,1), point (31,2), "OK", BT_OK);
  TButton *B_V=new TButton (point(21,3), point (31,4), "Vypnout", BT_USERDEF);
  TButton *B_C=new TButton (point(21,5), point (31,6), "Zrusit", BT_CANCEL);

  SyntaxDlg=new TDialog (point(20,6), point(58,18),6,
    array_of_comp (6,R,IL,L,B_OK,B_V, B_C), FR_DOUBLE, "Vyber syntaxe", WHITE);
} /* init_syntax_dlg */

//--------------------------- open_syntax_dlg  -----------------------------------------
int open_syntax_dlg (int &Syntax, string &FileName) {
  int Res=SyntaxDlg->open();
  Syntax=0;
  TRadioButtons *R=(TRadioButtons *)(SyntaxDlg->get_component(0));
  TInputLine *IL=(TInputLine *)(SyntaxDlg->get_component(1));
  FileName=IL->get_caption();

  for(uint i=0; i<R->get_count(); i++)
    if (R->checked (i)) Syntax=i;
  return (Res);
} /* open_syntax_dlg */

//--------------------------- open_choosefile_dlg  -----------------------------------------
int open_choosefile_dlg (string &FileName) {
  int Res=ChooseFileDlg->open();
  TInputLine *IL=(TInputLine *)(ChooseFileDlg->get_component(0));
  FileName=IL->get_caption();
  return (Res);
} /* open_choosefile_dlg */

//--------------------------- open_find_dlg  -----------------------------------------
int open_find_dlg (string &Str, int &CS, int &WW, int &Global) {
  int Res=FindDlg->open();
  TInputLine *IL=(TInputLine *)(FindDlg->get_component(0));
  Str=IL->get_caption();
  TCheckBoxes *C=(TCheckBoxes *)(FindDlg->get_component(4));
  CS=C->checked(0);
  WW=C->checked(1);
  TRadioButtons *R=(TRadioButtons *)(FindDlg->get_component(5));
  Global=R->checked(0);
  return (Res);
} /* open_find_dlg */

//--------------------------- get_find_dlg_opt  -----------------------------------------
void get_find_dlg_opt (string &Str, int &CS, int &WW, int &Global) {
  TInputLine *IL=(TInputLine *)(FindDlg->get_component(0));
  Str=IL->get_caption();
  TCheckBoxes *C=(TCheckBoxes *)(FindDlg->get_component(4));
  CS=C->checked(0);
  WW=C->checked(1);
  TRadioButtons *R=(TRadioButtons *)(FindDlg->get_component(5));
  Global=R->checked(0);
} /* get_find_dlg_opt */

//--------------------------- open_replace_dlg  -----------------------------------------
int open_replace_dlg (string &Str1, string &Str2, int &CS, int &WW, int &Global) {
  int Res=ReplaceDlg->open();
  TInputLine *IL=(TInputLine *)(ReplaceDlg->get_component(0));
  Str1=IL->get_caption();
  IL=(TInputLine *)(ReplaceDlg->get_component(1));
  Str2=IL->get_caption();

  TCheckBoxes *C=(TCheckBoxes *)(ReplaceDlg->get_component(6));
  CS=C->checked(0);
  WW=C->checked(1);
  TRadioButtons *R=(TRadioButtons *)(ReplaceDlg->get_component(7));
  Global=R->checked(0);
  return (Res);
} /* open_replace_dlg */

//--------------------------- free_choosefile_dlg  -----------------------------------------
void free_choosefile_dlg () {
  delete ChooseFileDlg;
} /* free_choosefile_dlg */

//--------------------------- free_find_dlg  -----------------------------------------
void free_find_dlg () {
  delete FindDlg;
} /* free_find_dlg */

//--------------------------- free_replace_dlg  -----------------------------------------
void free_replace_dlg () {
  delete ReplaceDlg;
} /* free_replace_dlg */
//--------------------------- free_syntax_dlg  -----------------------------------------
void free_syntax_dlg () {
  delete SyntaxDlg;
} /* free_syntax_dlg */
//--------------------------- set_error  -----------------------------------------
void set_error (int _Error) {
  Error=_Error;
} /* set_error */
//--------------------------- get_error  -----------------------------------------
int get_error () {
  return (Error);
} /* get_error */

//===========================  HLAVNI PROGRAM  ===============================
/*
void main ()
{

 clrscr();
 init_syntax_dlg ();
 int RR;
 string File;
 int R=open_syntax_dlg (RR, File);
 printf ("R=%d,RR=%d,S=%s",R,RR,File);
}
*/
